
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class AnnouncementsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const announcements = await db.announcements.create(
            {
                id: data.id || undefined,
        
        title_om: data.title_om
        ||
        null
            ,
            
        title_am: data.title_am
        ||
        null
            ,
            
        title_en: data.title_en
        ||
        null
            ,
            
        content_om: data.content_om
        ||
        null
            ,
            
        content_am: data.content_am
        ||
        null
            ,
            
        content_en: data.content_en
        ||
        null
            ,
            
        visibility: data.visibility
        ||
        null
            ,
            
        publish_from: data.publish_from
        ||
        null
            ,
            
        publish_until: data.publish_until
        ||
        null
            ,
            
        pinned: data.pinned
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.announcements.getTableName(),
                belongsToColumn: 'images',
                belongsToId: announcements.id,
            },
            data.images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.announcements.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: announcements.id,
            },
            data.attachments,
            options,
        );
        

        return announcements;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const announcementsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title_om: item.title_om
            ||
            null
            ,
            
                title_am: item.title_am
            ||
            null
            ,
            
                title_en: item.title_en
            ||
            null
            ,
            
                content_om: item.content_om
            ||
            null
            ,
            
                content_am: item.content_am
            ||
            null
            ,
            
                content_en: item.content_en
            ||
            null
            ,
            
                visibility: item.visibility
            ||
            null
            ,
            
                publish_from: item.publish_from
            ||
            null
            ,
            
                publish_until: item.publish_until
            ||
            null
            ,
            
                pinned: item.pinned
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const announcements = await db.announcements.bulkCreate(announcementsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < announcements.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.announcements.getTableName(),
                    belongsToColumn: 'images',
                    belongsToId: announcements[i].id,
                },
                data[i].images,
                options,
            );
        }
        
        for (let i = 0; i < announcements.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.announcements.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: announcements[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return announcements;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const announcements = await db.announcements.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title_om !== undefined) updatePayload.title_om = data.title_om;
        
        
        if (data.title_am !== undefined) updatePayload.title_am = data.title_am;
        
        
        if (data.title_en !== undefined) updatePayload.title_en = data.title_en;
        
        
        if (data.content_om !== undefined) updatePayload.content_om = data.content_om;
        
        
        if (data.content_am !== undefined) updatePayload.content_am = data.content_am;
        
        
        if (data.content_en !== undefined) updatePayload.content_en = data.content_en;
        
        
        if (data.visibility !== undefined) updatePayload.visibility = data.visibility;
        
        
        if (data.publish_from !== undefined) updatePayload.publish_from = data.publish_from;
        
        
        if (data.publish_until !== undefined) updatePayload.publish_until = data.publish_until;
        
        
        if (data.pinned !== undefined) updatePayload.pinned = data.pinned;
        
        
        updatePayload.updatedById = currentUser.id;

        await announcements.update(updatePayload, {transaction});

        
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.announcements.getTableName(),
                belongsToColumn: 'images',
                belongsToId: announcements.id,
            },
            data.images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.announcements.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: announcements.id,
            },
            data.attachments,
            options,
        );
        

        return announcements;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const announcements = await db.announcements.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of announcements) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of announcements) {
                await record.destroy({transaction});
            }
        });


        return announcements;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const announcements = await db.announcements.findByPk(id, options);

        await announcements.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await announcements.destroy({
            transaction
        });

        return announcements;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const announcements = await db.announcements.findOne(
            { where },
            { transaction },
        );

        if (!announcements) {
            return announcements;
        }

        const output = announcements.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.images = await announcements.getImages({
            transaction
        });
        
        
        output.attachments = await announcements.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



      {
        model: db.file,
        as: 'images',
      },

      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title_om) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'announcements',
                        'title_om',
                        filter.title_om,
                    ),
                };
            }
            
            if (filter.title_am) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'announcements',
                        'title_am',
                        filter.title_am,
                    ),
                };
            }
            
            if (filter.title_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'announcements',
                        'title_en',
                        filter.title_en,
                    ),
                };
            }
            
            if (filter.content_om) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'announcements',
                        'content_om',
                        filter.content_om,
                    ),
                };
            }
            
            if (filter.content_am) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'announcements',
                        'content_am',
                        filter.content_am,
                    ),
                };
            }
            
            if (filter.content_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'announcements',
                        'content_en',
                        filter.content_en,
                    ),
                };
            }
            

            
            

            
            if (filter.publish_fromRange) {
                const [start, end] = filter.publish_fromRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    publish_from: {
                    ...where.publish_from,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    publish_from: {
                    ...where.publish_from,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.publish_untilRange) {
                const [start, end] = filter.publish_untilRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    publish_until: {
                    ...where.publish_until,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    publish_until: {
                    ...where.publish_until,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.visibility) {
                where = {
                    ...where,
                visibility: filter.visibility,
            };
            }
            
            if (filter.pinned) {
                where = {
                    ...where,
                pinned: filter.pinned,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.announcements.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'announcements',
                        'title_en',
                        query,
                    ),
                ],
            };
        }

        const records = await db.announcements.findAll({
            attributes: [ 'id', 'title_en' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title_en', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title_en,
        }));
    }

    
};

